using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Commission
{
    public partial class Spec_add : Form
    {
        public Spec_add()
        {
            InitializeComponent();

            cbFill();
        }

        private void b_back_Click(object sender, EventArgs e)
        {
            Hide();
            Specialization spec = new Specialization();
            spec.Show();
            spec.Location = Location;
            DataBase.diagWrite("Переход на форму Специализации");
        }

        /// <summary>
        /// Проверка данных на корректность перед сохранением в БД
        /// </summary>
        /// <param name="check">Проверка пройдена (true) или нет (false)</param>
        private void checkData(ref bool check)
        {
            try
            {
                if (cb_faculty.SelectedIndex == -1)
                {
                    MessageBox.Show("Выберете из списка!", "Добавление специальности", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (t_spec.Text == "")
                {
                    MessageBox.Show("Введите наименование специальности корректно!", "Добавление специальности", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (t_ball.Text == "")
                {
                    MessageBox.Show("Введите проходной балл корректно!", "Добавление специальности", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else if (t_plan.Text == "")
                {
                    MessageBox.Show("Введите корректно план приема!", "Добавление специальности", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else
                {
                    check = true;
                }
            }
            catch
            {
                MessageBox.Show("Возникла ошибка. Проверьте введённые данные!", "Добавление специальности", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }


        /// <summary>
        /// Добавление данных в БД
        /// </summary>
        private void fillTable(string spec, int faculty, int plan, int ball)
        {
            SqlCommand command = new SqlCommand("INSERT INTO Specialization VALUES(@faculty, @spec, @ball, @plan)", DataBase.connection());
            command.Parameters.AddWithValue("faculty", faculty);
            command.Parameters.AddWithValue("spec", spec);
            command.Parameters.AddWithValue("plan", plan);
            command.Parameters.AddWithValue("ball", ball);
            command.ExecuteNonQuery();
        }
        private void b_add_Click(object sender, EventArgs e)
        {
            bool check = false;
            checkData(ref check);
            if (check)
            {
                fillTable(t_spec.Text, cb_faculty.SelectedIndex + 1, Convert.ToInt32(t_plan.Text), Convert.ToInt32(t_ball.Text));
                MessageBox.Show("Специальность успешно добавлена!", "Добавление специальности", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        /// <summary>
        /// Заполнение ComboBox
        /// </summary>
        private void cbFill()
        {
            SqlDataReader sqlReader = null;
            SqlCommand command = new SqlCommand("SELECT * FROM Faculty", DataBase.connection());
            sqlReader = command.ExecuteReader();
            while (sqlReader.Read())
            {
                cb_faculty.Items.Add(sqlReader["Faculty"]);
            }
            sqlReader.Close();
        }

        private void Spec_add_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.Exit();
        }

        private void Spec_add_Load(object sender, EventArgs e)
        {

        }
    }
}
